diff --git a/kernel/printk.c b/kernel/printk.c
index c2d6893..adbc6e9 100644
--- a/kernel/printk.c
+++ b/kernel/printk.c
@@ -413,8 +413,88 @@ static void emit_log_char(char c)
  * then changes console_loglevel may break. This is because console_loglevel
  * is inspected when the actual printing occurs.
  */
+#ifdef CONFIG_IPIPE
+
+static IPIPE_DEFINE_SPINLOCK(__ipipe_printk_lock);
+
+static int __ipipe_printk_fill;
+
+static char __ipipe_printk_buf[LOG_BUF_LEN];
+
+static int do_printk(const char *fmt, ...);
+
+void __ipipe_flush_printk (unsigned virq, void *cookie)
+{
+	char *p = __ipipe_printk_buf;
+	int len, lmax, out = 0;
+	unsigned long flags;
+
+	goto start;
+
+	do {
+		spin_unlock_irqrestore(&__ipipe_printk_lock, flags);
+ start:
+		lmax = __ipipe_printk_fill;
+		while (out < lmax) {
+			len = strlen(p) + 1;
+			do_printk("%s", p);
+			p += len;
+			out += len;
+		}
+		spin_lock_irqsave(&__ipipe_printk_lock, flags);
+	}
+	while (__ipipe_printk_fill != lmax);
+
+	__ipipe_printk_fill = 0;
+
+	spin_unlock_irqrestore(&__ipipe_printk_lock, flags);
+}
+
+int vscnprintf(char *buf, size_t size, const char *fmt, va_list args)
+{
+	int i = vsnprintf(buf,size,fmt,args);
+	return (i >= size) ? (size - 1) : i;
+}
+
 asmlinkage int printk(const char *fmt, ...)
 {
+    	unsigned long flags, oldcount;
+	int r, fbytes;
+	va_list args;
+
+	va_start(args, fmt);
+
+	spin_lock_irqsave(&__ipipe_printk_lock, flags);
+
+	oldcount = __ipipe_printk_fill;
+	fbytes = LOG_BUF_LEN - __ipipe_printk_fill;
+
+	if (fbytes > 1)	{
+		r = vscnprintf(__ipipe_printk_buf + __ipipe_printk_fill,
+			       fbytes, fmt, args) + 1; /* account for the null byte */
+		__ipipe_printk_fill += r;
+	} else
+		r = 0;
+
+	spin_unlock_irqrestore(&__ipipe_printk_lock, flags);
+
+	if (ipipe_current_domain == ipipe_root_domain ||
+	    test_bit(IPIPE_SPRINTK_FLAG,&ipipe_current_domain->flags) ||
+	    oops_in_progress) {
+		__ipipe_flush_printk(__ipipe_printk_virq, NULL);
+	} else if (oldcount == 0)
+	    	ipipe_trigger_irq(__ipipe_printk_virq);
+
+	va_end(args);
+
+	return r;
+}
+
+static int do_printk(const char *fmt, ...)
+#else /* !CONFIG_IPIPE */
+asmlinkage int printk(const char *fmt, ...)
+#endif /* CONFIG_IPIPE */
+{
 	va_list args;
 	unsigned long flags;
 	int printed_len;
@@ -486,6 +566,7 @@ asmlinkage int printk(const char *fmt, ...)
 out:
 	return printed_len;
 }
+
 EXPORT_SYMBOL(printk);
 
 /**
diff --git a/kernel/sched.c b/kernel/sched.c
index afd6d35..115f07b 100644
--- a/kernel/sched.c
+++ b/kernel/sched.c
@@ -29,6 +29,7 @@
 #include <linux/completion.h>
 #include <linux/prefetch.h>
 #include <linux/compiler.h>
+#include <linux/module.h>
 
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
@@ -359,6 +360,8 @@ static inline int try_to_wake_up(struct task_struct * p, int synchronous)
 	 * We want the common case fall through straight, thus the goto.
 	 */
 	spin_lock_irqsave(&runqueue_lock, flags);
+	if (p->state & TASK_NOWAKEUP)
+		goto out;
 	p->state = TASK_RUNNING;
 	if (task_on_runqueue(p))
 		goto out;
@@ -535,7 +538,61 @@ needs_resched:
 
 asmlinkage void schedule_tail(struct task_struct *prev)
 {
+#ifdef CONFIG_IPIPE
+	local_irq_disable();
+	local_irq_enable_hw();
+#endif /* CONFIG_IPIPE */
 	__schedule_tail(prev);
+	ipipe_init_notify(current);
+#ifdef CONFIG_IPIPE
+	local_irq_enable();
+#endif /* CONFIG_IPIPE */
+}
+
+static struct delayed_mmreq {
+	int in;
+	int out;
+	int count;
+#define MAX_DELAYED_MM  128  /* need ^2 here. */
+	struct mm_struct *mm[MAX_DELAYED_MM];
+} delayed_mmtab[NR_CPUS];
+
+static void __ipipe_delay_mmdrop (struct task_struct *prev)
+{
+	struct delayed_mmreq *p;
+	struct mm_struct *oldmm;
+
+    	if (prev->mm)
+		return;
+
+	p = delayed_mmtab + prev->processor;
+	oldmm = prev->active_mm;
+
+	BUG_ON(p->count >= MAX_DELAYED_MM);
+	/*
+	 * Prevent the mm from being dropped in schedule() since this
+	 * could cause 1) large latencies to high priority domains
+	 * hijacking Linux tasks, 2) subtle mm recycling error at task
+	 * exit due to co-scheduling issues, then pend a request to
+	 * drop it later in __ipipe_mmdrop_sync() when Linux is back
+	 * in control.
+	 */
+	atomic_inc(&oldmm->mm_count);
+	p->mm[p->in] = oldmm;
+	p->in = (p->in + 1) & (MAX_DELAYED_MM - 1);
+	p->count++;
+}
+
+static void __ipipe_sync_mmdrop (void)
+{
+    	struct delayed_mmreq *p = delayed_mmtab + smp_processor_id();
+
+	while (p->out != p->in) {
+		struct mm_struct *oldmm = p->mm[p->out];
+		mmdrop(oldmm);
+		p->out = (p->out + 1) & (MAX_DELAYED_MM - 1);
+		p->count--;
+	}
 }
 
 /*
@@ -673,6 +730,8 @@ repeat_schedule:
 	 * This might sound slightly confusing but makes tons of sense.
 	 */
 	prepare_to_switch();
+	prepare_arch_switch(next);
+	__ipipe_delay_mmdrop(prev);
 	{
 		struct mm_struct *mm = next->mm;
 		struct mm_struct *oldmm = prev->active_mm;
@@ -706,6 +765,9 @@ repeat_schedule:
 	}
 #endif
 	switch_to(prev, next, prev);
+	if (task_hijacked(prev))
+	    return;
+	__ipipe_sync_mmdrop();
 	__schedule_tail(prev);
 
 same_process:
@@ -1004,6 +1066,7 @@ static int setscheduler(pid_t pid, int policy,
 	retval = 0;
 	p->policy = policy;
 	p->rt_priority = lp.sched_priority;
+	ipipe_setsched_notify(p);
 
 	current->need_resched = 1;
 
@@ -1408,3 +1471,34 @@ void __init sched_init(void)
 	atomic_inc(&init_mm.mm_count);
 	enter_lazy_tlb(&init_mm, current, cpu);
 }
+
+#ifdef CONFIG_IPIPE
+
+int ipipe_setscheduler_root (struct task_struct *p, int policy, int prio)
+{
+	read_lock_irq(&tasklist_lock);
+	spin_lock(&runqueue_lock);
+
+	p->policy = policy;
+	p->rt_priority = prio;
+	current->need_resched = 1;
+
+	spin_unlock(&runqueue_lock);
+	read_unlock_irq(&tasklist_lock);
+
+	return 0;
+}
+
+int ipipe_reenter_root (struct task_struct *prev, int policy, int prio)
+{
+    	__schedule_tail(prev);
+	reacquire_kernel_lock(current);
+	local_irq_enable();
+
+	if (current->policy != policy || current->rt_priority != prio)
+		return ipipe_setscheduler_root(current,policy,prio);
+
+	return 0;
+}
+
+#endif /* CONFIG_IPIPE */
diff --git a/kernel/signal.c b/kernel/signal.c
index 77371a0..7fb130d 100644
--- a/kernel/signal.c
+++ b/kernel/signal.c
@@ -495,6 +495,7 @@ static int send_signal(int sig, struct siginfo *info, struct sigpending *signals
 static inline void signal_wake_up(struct task_struct *t)
 {
 	t->sigpending = 1;
+	ipipe_sigwake_notify(t); /* t->sigpending must be set first. */
 
 #ifdef CONFIG_SMP
 	/*
